GDAL

- Main Page
- Related Pages
- Classes
- Files
- Download
- Issue Tracker

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
OGRPolyhedralSurface Class Reference

PolyhedralSurface class. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRPolyhedralSurface:

## Public Member Functions
| OGRPolyhedralSurface ()
| Create an empty PolyhedralSurface.
| OGRPolyhedralSurface (const OGRPolyhedralSurface &poGeom)
| Copy constructor.
virtual | ~OGRPolyhedralSurface ()
| Destructor. More...
OGRPolyhedralSurface & | operator= (const OGRPolyhedralSurface &other)
| Assignment operator.
virtual int | WkbSize () const CPL_OVERRIDE
| Returns size of related binary representation. More...
virtual const char * | getGeometryName () const CPL_OVERRIDE
| Fetch WKT name for geometry type. More...
virtual OGRwkbGeometryType | getGeometryType () const CPL_OVERRIDE
| Returns the WKB Type of PolyhedralSurface. More...
virtual OGRErr | importFromWkb (unsigned char *, int=-1, OGRwkbVariant=wkbVariantOldOgc) CPL_OVERRIDE
| Assign geometry from well known binary data. More...
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const CPL_OVERRIDE
| Convert a geometry into well known binary format. More...
virtual OGRErr | importFromWkt (char **) CPL_OVERRIDE
| Assign geometry from well known text data. More...
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const CPL_OVERRIDE
| Convert a geometry into well known text format. More...
virtual int | getDimension () const CPL_OVERRIDE
| Get the dimension of this object. More...
virtual void | empty () CPL_OVERRIDE
| Clear geometry information. More...
virtual OGRGeometry * | clone () const CPL_OVERRIDE
| Make a copy of this object. More...
virtual void | getEnvelope (OGREnvelope *psEnvelope) const CPL_OVERRIDE
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const CPL_OVERRIDE
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
virtual void | flattenTo2D () CPL_OVERRIDE
| Convert geometry to strictly 2D. More...
virtual OGRErr | transform (OGRCoordinateTransformation *) CPL_OVERRIDE
| Apply arbitrary coordinate transformation to geometry. More...
virtual OGRBoolean | Equals (OGRGeometry *) const CPL_OVERRIDE
| Returns TRUE if two geometries are equivalent. More...
virtual double | get_Area () const CPL_OVERRIDE
| Returns the area enclosed. More...
virtual OGRErr | PointOnSurface (OGRPoint *) const CPL_OVERRIDE
| This method relates to the SFCOM ISurface::get_PointOnSurface() method. More...
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const CPL_OVERRIDE
| Returns if this geometry is or has curve geometry. More...
virtual OGRErr | addGeometry (const OGRGeometry *)
| Add a new geometry to a collection. More...
OGRErr | addGeometryDirectly (OGRGeometry *poNewGeom)
| Add a geometry directly to the container. More...
int | getNumGeometries () const
| Fetch number of geometries in PolyhedralSurface. More...
OGRGeometry * | getGeometryRef (int i)
| Fetch geometry from container. More...
const OGRGeometry * | getGeometryRef (int i) const
| Fetch geometry from container. More...
virtual OGRBoolean | IsEmpty () const CPL_OVERRIDE
| Checks if the PolyhedralSurface is empty. More...
virtual void | setCoordinateDimension (int nDimension) CPL_OVERRIDE
| Set the coordinate dimension. More...
virtual void | set3D (OGRBoolean bIs3D) CPL_OVERRIDE
| Set the type as 3D geometry.
virtual void | setMeasured (OGRBoolean bIsMeasured) CPL_OVERRIDE
| Set the type as Measured.
virtual void | swapXY () CPL_OVERRIDE
| Swap x and y coordinates.
OGRErr | removeGeometry (int iIndex, int bDelete=TRUE)
| Remove a geometry from the container. More...
Public Member Functions inherited from OGRGeometry
| OGRGeometry (const OGRGeometry &other)
| Copy constructor. More...
OGRGeometry & | operator= (const OGRGeometry &other)
| Assignment operator. More...
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid. More...
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple. More...
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring. More...
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3. More...
virtual void | dumpReadable (FILE *, const char *=NULL, char **papszOptions=NULL) const
| Dump geometry in well known text format to indicated output file. More...
virtual char * | exportToGML (const char *const *papszOptions=NULL) const
| Convert a geometry into GML format. More...
virtual char * | exportToKML () const
| Convert a geometry into KML format. More...
virtual char * | exportToJson () const
| Convert a geometry into GeoJSON format. More...
virtual GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt) const CPL_WARN_UNUSED_RESULT
| Returns a GEOSGeom object corresponding to the geometry. More...
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=NULL) const CPL_WARN_UNUSED_RESULT
| Return curve version of this geometry. More...
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const CPL_WARN_UNUSED_RESULT
| Return, possibly approximate, non-curve version of this geometry. More...
virtual void | closeRings ()
| Force rings to be closed. More...
void | assignSpatialReference (OGRSpatialReference *poSR)
| Assign spatial reference to this object. More...
OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object. More...
OGRErr | transformTo (OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system. More...
virtual void | segmentize (double dfMaxLength)
| Modify the geometry such it has no segment longer then the given distance. More...
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect? More...
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness. More...
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching. More...
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing. More...
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap. More...
virtual OGRGeometry * | Boundary () const CPL_WARN_UNUSED_RESULT
| Compute boundary. More...
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries. More...
virtual OGRGeometry * | ConvexHull () const CPL_WARN_UNUSED_RESULT
| Compute convex hull. More...
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const CPL_WARN_UNUSED_RESULT
| Compute buffer of geometry. More...
virtual OGRGeometry * | Intersection (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute intersection. More...
virtual OGRGeometry * | Union (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute union. More...
virtual OGRGeometry * | UnionCascaded () const CPL_WARN_UNUSED_RESULT
| Compute union using cascading. More...
virtual OGRGeometry * | Difference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute difference. More...
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute symmetric difference. More...
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid. More...
virtual OGRGeometry * | Simplify (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry. More...
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry while preserving topology. More...
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const CPL_WARN_UNUSED_RESULT
| Return a Delaunay triangulation of the vertices of the geometry. More...
virtual OGRGeometry * | Polygonize () const CPL_WARN_UNUSED_RESULT
| Polygonizes a set of sparse edges. More...
virtual double | Distance3D (const OGRGeometry *poOtherGeom) const
| Returns the 3D distance between two geometries. More...

## Static Public Member Functions
static OGRMultiPolygon * | CastToMultiPolygon (OGRPolyhedralSurface *poPS)
| Casts the OGRPolyhedralSurface to an OGRMultiPolygon. More...
Static Public Member Functions inherited from OGRGeometry
static GEOSContextHandle_t | createGEOSContext ()
| Create a new GEOS context. More...
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
| Destroy a GEOS context. More...

## Detailed Description

PolyhedralSurface class.

Since
  GDAL 2.2

## Constructor & Destructor Documentation

OGRPolyhedralSurface::~OGRPolyhedralSurface | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

OGRErr OGRPolyhedralSurface::addGeometry | ( | const OGRGeometry * | poNewGeom | ) |
| virtual

Add a new geometry to a collection.

Only a POLYGON can be added to a POLYHEDRALSURFACE.

Returns
  OGRErr OGRERR_NONE if the polygon is successfully added

Reimplemented in OGRTriangulatedSurface.

OGRErr OGRPolyhedralSurface::addGeometryDirectly | ( | OGRGeometry * | poNewGeom | ) |

Add a geometry directly to the container.

This method is the same as the C function OGR_G_AddGeometryDirectly().

There is no SFCOM analog to this method.

Parameters

  poNewGeom | geometry to add to the container.

Returns
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

OGRMultiPolygon * OGRPolyhedralSurface::CastToMultiPolygon | ( | OGRPolyhedralSurface * | poPS | ) |
| static

Casts the OGRPolyhedralSurface to an OGRMultiPolygon.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters

  poPS | the input geometry - ownership is passed to the method.

Returns
  new geometry.

OGRGeometry * OGRPolyhedralSurface::clone | ( |  | ) | const
| virtual

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

void OGRPolyhedralSurface::empty | ( |  | ) |
| virtual

Clear geometry information.

This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

OGRBoolean OGRPolyhedralSurface::Equals | ( | OGRGeometry * | poOtherGeom | ) | const
| virtual

Returns TRUE if two geometries are equivalent.

This operation implements the SQL/MM ST_OrderingEquals() operation.

The comparison is done in a structural way, that is to say that the geometry types must be identical, as well as the number and ordering of sub-geometries and vertices. Or equivalently, two geometries are considered equal by this method if their WKT/WKB representation is equal. Note: this must be distinguished for equality in a spatial way (which is the purpose of the ST_Equals() operation).

This method is the same as the C function OGR_G_Equals().

Returns
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

OGRErr OGRPolyhedralSurface::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| virtual

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters

  eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

OGRErr OGRPolyhedralSurface::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| virtual

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters

  ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with CPLFree().
  eWkbVariant | the specification that must be conformed too : wbkVariantOgc for old-style 99-402 extended dimension (Z) WKB types wbkVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

void OGRPolyhedralSurface::flattenTo2D | ( |  | ) |
| virtual

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

double OGRPolyhedralSurface::get_Area | ( |  | ) | const
| virtual

Returns the area enclosed.

This method is built on the SFCGAL library, check it for the definition of the geometry operation. If OGR is built without the SFCGAL library, this method will always return -1.0

Returns
  area enclosed by the PolyhedralSurface

Implements OGRSurface.

int OGRPolyhedralSurface::getDimension | ( |  | ) | const
| virtual

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns
  0 for points, 1 for lines and 2 for surfaces.

Implements OGRGeometry.

void OGRPolyhedralSurface::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const
| virtual

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters

  psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

void OGRPolyhedralSurface::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const
| virtual

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters

  psEnvelope | the structure in which to place the results.

Since
  OGR 1.9.0

Implements OGRGeometry.

const char * OGRPolyhedralSurface::getGeometryName | ( |  | ) | const
| virtual

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implements OGRGeometry.

Reimplemented in OGRTriangulatedSurface.

OGRGeometry * OGRPolyhedralSurface::getGeometryRef | ( | int | i | ) |

Fetch geometry from container.

This method returns a pointer to an geometry within the container. The returned geometry remains owned by the container, and should not be modified. The pointer is only valid until the next change to the geometry container. Use IGeometry::clone() to make a copy.

Parameters

  i | the index of the geometry to fetch, between 0 and getNumGeometries() - 1.

Returns
  pointer to requested geometry.

const OGRGeometry * OGRPolyhedralSurface::getGeometryRef | ( | int | i | ) | const

Fetch geometry from container.

This method returns a pointer to an geometry within the container. The returned geometry remains owned by the container, and should not be modified. The pointer is only valid until the next change to the geometry container. Use IGeometry::clone() to make a copy.

Parameters

  i | the index of the geometry to fetch, between 0 and getNumGeometries() - 1.

Returns
  pointer to requested geometry.

OGRwkbGeometryType OGRPolyhedralSurface::getGeometryType | ( |  | ) | const
| virtual

Returns the WKB Type of PolyhedralSurface.

Implements OGRGeometry.

Reimplemented in OGRTriangulatedSurface.

int OGRPolyhedralSurface::getNumGeometries | ( |  | ) | const

Fetch number of geometries in PolyhedralSurface.

Returns
  count of children geometries. May be zero.

OGRBoolean OGRPolyhedralSurface::hasCurveGeometry | ( | int | bLookForNonLinear = `FALSE` | ) | const
| virtual

Returns if this geometry is or has curve geometry.

Returns if a geometry is, contains or may contain a CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE.

If bLookForNonLinear is set to TRUE, it will be actually looked if the geometry or its subgeometries are or contain a non-linear geometry in them. In which case, if the method returns TRUE, it means that getLinearGeometry() would return an approximate version of the geometry. Otherwise, getLinearGeometry() would do a conversion, but with just converting container type, like COMPOUNDCURVE -> LINESTRING, MULTICURVE -> MULTILINESTRING or MULTISURFACE -> MULTIPOLYGON, resulting in a "loss-less" conversion.

This method is the same as the C function OGR_G_HasCurveGeometry().

Parameters

  bLookForNonLinear | set it to TRUE to check if the geometry is or contains a CIRCULARSTRING.

Returns
  TRUE if this geometry is or has curve geometry.

Since
  GDAL 2.0

Reimplemented from OGRGeometry.

OGRErr OGRPolyhedralSurface::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  |
| virtual

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or zero if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

OGRErr OGRPolyhedralSurface::importFromWkt | ( | char ** | ppszInput | ) |
| virtual

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters

  ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

OGRBoolean OGRPolyhedralSurface::IsEmpty | ( |  | ) | const
| virtual

Checks if the PolyhedralSurface is empty.

Returns
  TRUE if the PolyhedralSurface is empty, FALSE otherwise

Implements OGRGeometry.

OGRErr OGRPolyhedralSurface::PointOnSurface | ( | OGRPoint * | poPoint | ) | const
| virtual

This method relates to the SFCOM ISurface::get_PointOnSurface() method.

NOTE: Only implemented when GEOS included in build.

Parameters

  poPoint | point to be set with an internal point.

Returns
  OGRERR_NONE if it succeeds or OGRERR_FAILURE otherwise.

Implements OGRSurface.

OGRErr OGRPolyhedralSurface::removeGeometry | ( | int | iGeom,
|  | int | bDelete = `TRUE`
| ) |  |

Remove a geometry from the container.

Removing a geometry will cause the geometry count to drop by one, and all "higher" geometries will shuffle down one in index.

Parameters

  iGeom | the index of the geometry to delete. A value of -1 is a special flag meaning that all geometries should be removed.
  bDelete | if TRUE the geometry will be deallocated, otherwise it will not. The default is TRUE as the container is considered to own the geometries in it.

Returns
  OGRERR_NONE if successful, or OGRERR_FAILURE if the index is out of range.

void OGRPolyhedralSurface::setCoordinateDimension | ( | int | nNewDimension | ) |
| virtual

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. This will also remove the M dimension if present before this call.

Parameters

  nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented from OGRGeometry.

OGRErr OGRPolyhedralSurface::transform | ( | OGRCoordinateTransformation * | poCT | ) |
| virtual

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters

  poCT | the transformation to apply.

Returns
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

int OGRPolyhedralSurface::WkbSize | ( |  | ) | const
| virtual

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns
  size of binary representation in bytes.

Implements OGRGeometry.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrpolyhedralsurface.cpp

Generated for GDAL by 1.8.8.